Index: .cvsignore
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.4
diff -u -p -b -r1.2 -r1.4
--- .cvsignore	16 Jun 2004 14:25:15 -0000	1.2
+++ .cvsignore	15 Jul 2004 12:10:43 -0000	1.4
@@ -2,6 +2,7 @@ depend
 ChangeLog*
 Makefile
 configure
+config.cache
 config.status
 config.log
 config.h
@@ -9,3 +10,4 @@ autom4te.cache
 babyftpd
 *.o
 *.swp
+*.pem
Index: Commands.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands.cpp,v
retrieving revision 1.189
retrieving revision 1.227
diff -u -p -b -r1.189 -r1.227
--- Commands.cpp	10 Jul 2004 14:14:45 -0000	1.189
+++ Commands.cpp	16 Jan 2005 00:58:16 -0000	1.227
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: Commands.cpp
+// $Id: Commands.cpp,v 1.227 2005/01/16 00:58:16 klas Exp $
+//
 // Usage: Ftp commands and data transfer functions
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
@@ -14,25 +15,40 @@
 bool Commands::ftp_send(User *user, string message)
 {
   int ret;
-  message += "\r\n";
-  pthread_mutex_lock(&user->lock);
+  fd_set wfds;
+  struct timeval tv;
+
+  if(user->socket_id < 0)
+  {
+    user->logged_in = LOGGED_OUT;
+    return(false);
+  }
+  FD_ZERO(&wfds);
+  FD_SET(user->socket_id, &wfds);
+  tv.tv_sec = 1;
+  tv.tv_usec = 0;
   
+  sem_wait(&user->user_lock);
+  if(!select(user->socket_id + 1, NULL, &wfds, NULL, &tv))
+  {
+    user->logged_in = LOGGED_OUT;
+    sem_post(&user->user_lock);
+    return(false);
+  }
+  message += "\r\n";
 #ifdef USE_TLS
-  if(is_set(user->settings, TLS_ENABLED))
-    ret = gnutls_record_send(user->ctrl_session, (void*)message.c_str(), message.size());
+  if(user->settings.test(TLS_ENABLED))
+    ret = gnutls_record_send(user->ctrl_session, static_cast<const void*>(message.c_str()), message.size());
   else
 #endif // USE_TLS
-    ret = write(user->socket_id, (void*)message.c_str(), message.size());
+    ret = write(user->socket_id, static_cast<const void*>(message.c_str()), message.size());
 
+  sem_post(&user->user_lock);
   if(ret < 0)
   {
-    pthread_mutex_unlock(&user->lock);
-    pthread_mutex_lock(&sys_log_lock);
-    syslog(LOG_ERR, "write to socket %d failed: %m", user->socket_id);
-    pthread_mutex_unlock(&sys_log_lock);
+    logging->log_this(3, TYPE_INFO, "write to socket " + util.itos(user->socket_id) + " failed: %m"); // I think %m should work here as well.. maybe?
     return(false);
   }
-  pthread_mutex_unlock(&user->lock);
   return(true);
 }
 
@@ -47,50 +63,41 @@ bool Commands::ftp_receive(User *user, s
   // We _really_ want to pass rfd as a reference...
   FD_ZERO(&rfd);
   FD_SET(user->socket_id, &rfd);
-  int max_fd = user->socket_id + 1;
   
-  if(!(select(max_fd, &rfd, NULL, NULL, &time)))
+  if(!(select(user->socket_id + 1, &rfd, NULL, NULL, &time)))
   {
     if(user->data_vec.size())
       return(false);
     Commands::ftp_send(user, "421 Connection timed out(" + util.itos(config->get_user(user->user_name).idle) + " seconds). Disconnected.");
     if(user->logged_in == LOGGED_IN)
-    {
-      string log;
-      log = "User " + user->user_name + ", disconnected due to timeout.";
-      pthread_mutex_lock(&sys_log_lock);
-      syslog(LOG_INFO, log.c_str());
-      pthread_mutex_unlock(&sys_log_lock);
-    }
-    pthread_mutex_lock(&user->lock);
+      logging->log_this(3, TYPE_AUTH, "User " + user->user_name + ", disconnected due to timeout.");
+
+    sem_wait(&user->user_lock);
     user->logged_in = LOGGED_OUT;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
     close(user->socket_id);
     return(false);
   }
   
-  char *tmp_buf = new char[210];
-  memset((void*)tmp_buf, '\0', 210); // making sure a variable is empty is damn important.
+  char tmp_buf[210] = { 0 };
   
 #ifdef USE_TLS
-  if(is_set(user->settings, TLS_ENABLED))
-    gnutls_record_recv(user->ctrl_session, (void*)tmp_buf, 200);
+  if(user->settings.test(TLS_ENABLED))
+    gnutls_record_recv(user->ctrl_session, static_cast<void*>(tmp_buf), 200);
   else
 #endif // USE_TLS
-    read(user->socket_id, (void*)tmp_buf, 200);
+    read(user->socket_id, static_cast<void*>(tmp_buf), 200);
   message.assign(tmp_buf, (strlen(tmp_buf)));
   
-  delete[] tmp_buf;
-  
   if(message.size() == 2) // no need to try parsing just "\r\n"
     return(false);
   if(message.size() == 0)
   {
     // this code makes sure that we don't get stuck in an endless loop if the connection just dissapears...
     close(user->socket_id);
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     user->logged_in = LOGGED_OUT;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
     return(false);
   }
   else // everything is normal and we've got a string to play with
@@ -99,58 +106,52 @@ bool Commands::ftp_receive(User *user, s
 
 void *data_wrapper(void *void_data)
 {
-  class Data *data = (class Data*)void_data;
-  class dns_wrapper *dns_wrap = new dns_wrapper;
+  class Data *data = static_cast<class Data*>(void_data);
   extern class Commands comm;
-  string type, message, log_message;
-  int log_type = 0;
-  size_t read_size; // for lack of finding a good define that fits here.
-  struct passwd *pwd;
-  uid_t uid;
-  gid_t gid;
+  string message;
+  size_t read_size = READ_SIZE; // for lack of finding a good define that fits here.
   fd_set set; // no, it isn't a bad name, but we'll use it for both RETR and STOR
-  struct timeval time;
+  struct timeval timeout;
+  time_t start_time = time(NULL);
+  size_t trans_size = 0; // will hold the total number of sent bytes
 
-  time.tv_sec = config->get_user(data->user->user_name).idle; // same timeout for data as control?
-  time.tv_usec = 0;
+  timeout.tv_sec = 5; // same timeout for data as control? no, 5 seconds is more than enough.
+  timeout.tv_usec = 0;
 
-  pthread_setspecific(my_object, (void*)data);
+
+  pthread_setspecific(my_data, void_data);
+  pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
 
   data->host_name = inet_ntoa(data->data_addr.sin_addr);
 
-  setpwent(); // I don't like it, but we need to drop permissions again...
-  pwd = getpwnam(data->user->user_name.c_str());
-  uid = pwd->pw_uid;
-  gid = pwd->pw_gid;
-  endpwent();
+  // I don't like it, but we need to drop permissions again...
+  struct passwd pwd, *pwd_ptr;
+  char pwdata[PWBUF_SIZE];
+  getpwnam_r(data->user->user_name.c_str(), &pwd, pwdata, sizeof(pwdata), &pwd_ptr);
+  uid_t uid = pwd.pw_uid;
+  gid_t gid = pwd.pw_gid;
   setuid(uid);
   setgid(gid);
 
   FD_ZERO(&set);
   FD_SET(data->data_id, &set);
   
-  pthread_mutex_lock(&data->data_lock);
+  sem_wait(&data->data_lock);
   data->thread_id = pthread_self();
-  dns_wrap->addr = data->data_addr;
-  dns_wrap->host_name = &data->host_name;
-  dns_lookup((void*)dns_wrap);
-  //pthread_create(&data->dns_thread, NULL, dns_lookup, (void*)dns_wrap); // new thread for dns lookup.
-  //pthread_detach(data->dns_thread);
-  pthread_mutex_unlock(&data->data_lock);
+  // do a dns lookup here.
+  sem_post(&data->data_lock);
 
-  if(!(select(data->data_id + 1, &set, &set, NULL, &time)))
+  if(!(select(data->data_id + 1, &set, &set, NULL, &timeout)))
   {
     message = "451 Data connection timed out(" + util.itos(config->get_user(data->user->user_name).idle) + " seconds).";
-    log_message = "User " + data->user->user_name + ", lost a data connection due to timeout.";
-    log_type = LOG_INFO;
+    logging->log_this(3, TYPE_INFO, "User " + data->user->user_name + ", lost a data connection due to timeout.");
   }
 #ifdef USE_TLS // handshakes etc
-  else if(is_set(data->settings, TLS_INITED))
+  else if(data->settings.test(TLS_INITED))
   {
-    int ret;
-    pthread_mutex_lock(&data->data_lock);
-    ret = gnutls_handshake(data->data_session);
-    pthread_mutex_unlock(&data->data_lock);
+    sem_wait(&data->data_lock);
+    int ret = gnutls_handshake(data->data_session);
+    sem_post(&data->data_lock);
     if(ret < 0) // failed handshake
     {
       message = "451 Failed to negotiate TLS as was asked. Closing data connection.";
@@ -158,26 +159,25 @@ void *data_wrapper(void *void_data)
     }
     else // handshake is aok
     {
+      // tls is picky about how much in one send/recv
       read_size = gnutls_record_get_max_size(data->data_session);
-      pthread_mutex_lock(&data->data_lock);
-      set_bit(data->settings, TLS_ENABLED);
-      pthread_mutex_unlock(&data->data_lock);
+      sem_wait(&data->data_lock);
+      data->settings.set(TLS_ENABLED);
+      sem_post(&data->data_lock);
     }
   }
-  else
 #endif // USE_TLS
-    read_size = 16384;
   while(data->data_id && message.size() == 0)
   {
-    char *read_buf = new char[read_size];
+    char read_buf[read_size];
     size_t size, size2;
-    if(is_set(data->settings, RETR_TRANS))
+    if(data->settings.test(RETR_TRANS))
       size2 = read(data->file_id, read_buf, read_size);
 
 #ifdef USE_TLS
-    if(is_set(data->settings, TLS_ENABLED))
+    if(data->settings.test(TLS_ENABLED))
     {
-      if(is_set(data->settings, RETR_TRANS))
+      if(data->settings.test(RETR_TRANS))
         size = gnutls_record_send(data->data_session, read_buf, size2);
       else // STOR_TRANS
         size = gnutls_record_recv(data->data_session, read_buf, read_size);
@@ -185,19 +185,19 @@ void *data_wrapper(void *void_data)
     else
     {
 #endif
-      if(is_set(data->settings, RETR_TRANS))
+      if(data->settings.test(RETR_TRANS))
         size = write(data->data_id, read_buf, size2);
       else // STOR_STRANS
         size = recv(data->data_id, read_buf, read_size, MSG_WAITALL);
 #ifdef USE_TLS
     } // the else just before last #endif
 #endif
-    if(!is_set(data->settings, RETR_TRANS))
+    trans_size += size;
+    if(!data->settings.test(RETR_TRANS))
     {
       if(size != 0 && (write(data->file_id, read_buf, size) == -1))
       {
-        log_message = "Write failed to file: " + data->file_name + " from host: " + data->host_name + " with error %m";
-        log_type = LOG_DEBUG;
+        logging->log_this(3, TYPE_DEBUG, "Write failed to file: " + data->file_name + " from host: " + data->host_name + " with error %m");
         message = "451 File transfer failed.";
       }
       else if(size == 0)
@@ -215,82 +215,98 @@ void *data_wrapper(void *void_data)
       else if(size2 != read_size)
         message = "226 Transfer complete.";
     }
-    delete[] read_buf;
   }
   
-  if(log_message.size() > 0)
-  {
-    pthread_mutex_lock(&sys_log_lock);
-    syslog(log_type, log_message.c_str());  
-    pthread_mutex_unlock(&sys_log_lock);
-  }
   comm.ftp_send(data->user, message);
-  delete data;
-  //pthread_exit(NULL);
-  return(NULL);
+  if(config->logger.xferlog)
+  {
+    const time_t timep = time(NULL);
+    struct tm now;
+    char time_string[30] = {0};
+
+    gmtime_r(&timep, &now);
+    strftime(time_string, 28, "%a %b %d %H:%M:%S %Y ", &now);
+
+    // let us build a string!
+    string xferlog = time_string;
+    xferlog += util.itos(time(NULL) - start_time);
+    xferlog += " " + data->host_name;
+    xferlog += " " + util.itos(trans_size);
+    xferlog += " " + data->file_name + " ";
+    xferlog += (data->settings.test(BINARY)?"b":"a");
+    xferlog += " _ "; // we don't support any special-action to flag here.. or is encryption special? have to make up a flag I guess ;)
+    xferlog += (data->settings.test(RETR_TRANS)?"o":"i");
+    xferlog += " r"; // same thing again, we only support real users so far.. 
+    xferlog += " " + data->user->user_name;
+    xferlog += " FTP"; // maybe ftps for encrypted?
+    xferlog += " 0"; // there should be more auth methods available here?
+    xferlog += " *"; // or should this be uid?
+
+    logging->log_this(1, TYPE_XFER, xferlog);
+  }
+  sem_wait(&data->user->user_lock);
+  data->user->total_transfered += trans_size;
+  sem_post(&data->user->user_lock);
+
+  pthread_exit(NULL);
 }
 
-// XXX look at using realpath() in this function, should work ALOT better.
+// parsing strings so we get something good to work with,
+// beware of this function, it is one of the most expensive
+// functions in the game...
 string Commands::parsedir(User *user, string orig_string)
 {
-  string *dir_array;
   string new_string;
-  int token_count;
 
   if(orig_string[0] != '/')
     orig_string = user->current_dir + '/' + orig_string;
       
   class StringTokenizer *token = new StringTokenizer(orig_string, "/", false);
+  vector<string> dir_array;
+  dir_array.reserve(token->countTokens());
 
-  dir_array = new string[token->countTokens()];
+  while(token->hasMoreTokens())
+  {
+    dir_array.push_back(token->nextToken());
 
-  for(token_count = 0; token->hasMoreTokens(); token_count++)
+    if(dir_array.back().size() < 3)
+    { // to save us from expensive string comparisons
+      if(dir_array.back() == "..")
   {
-    if(token_count < 0)
-      token_count = 0;
-    dir_array[token_count] = token->nextToken();
-    if(dir_array[token_count] == "..")
-      token_count -= 2;
-    else if(dir_array[token_count] == ".")
-      token_count -= 1;
+        dir_array.pop_back();
+        if(!dir_array.empty())
+          dir_array.pop_back();
   }
+      else if(dir_array.back() == ".")
+        dir_array.pop_back();
+    }
+  }
+  delete token;
 
-  if(token_count < 1)
+  if(dir_array.empty())
     new_string = '/';
   else
-  {
-    for(int i = 0; i != token_count; i++)
-      new_string += '/' + dir_array[i];
-  }
-
-  delete[] dir_array;
-  delete token;
+    for(vector<string>::iterator dir_it = dir_array.begin(); dir_it != dir_array.end(); dir_it++)
+      new_string += '/' + *dir_it;
 
-  if(config->get_user(user->user_name).only_home)
+  if(user->root_dir.size() > 1)
     if(new_string.find(user->root_dir) != 0)
-    //if(new_string.compare(0, user->root_dir.size(), user->root_dir) != 0)
       new_string = user->root_dir + new_string;
 
+
   return(new_string);
 }
 
 #ifdef USE_TLS
 
-gnutls_session Commands::init_tls(void)
+void Commands::init_tls(gnutls_session &session)
 {
-  gnutls_session session;
-
   gnutls_init(&session, GNUTLS_SERVER);
 
-  /* avoid calling all the priority functions, since the defaults
-   * *     * are adequate.
-   * *         */
   gnutls_set_default_priority(session);   
 
   gnutls_credentials_set(session, GNUTLS_CRD_CERTIFICATE, x509_cred);
 
-  /* request client certificate if any.
-   * *     */
   gnutls_certificate_server_set_request(session, GNUTLS_CERT_REQUEST);
 
   gnutls_dh_set_prime_bits(session, 1024);
@@ -299,8 +315,49 @@ gnutls_session Commands::init_tls(void)
   gnutls_db_set_remove_function(session, tls_db_delete);
   gnutls_db_set_store_function(session, tls_db_store);
   gnutls_db_set_ptr(session, NULL);
-  
-  return session;
 }
-
 #endif // USE_TLS
+
+int pam_conversate(int num_msg, const struct pam_message **msg,
+    struct pam_response **resp, void *appdata_ptr)
+{
+  struct pam_response *reply = new struct pam_response[0];
+  int count = 0;
+  struct pam_data *auth_data = (static_cast<struct pam_data*>(appdata_ptr));
+
+  for(int i = 0; i < num_msg; i++)
+  {
+    switch(msg[i]->msg_style)
+    {
+      case PAM_PROMPT_ECHO_ON:
+      case PAM_PROMPT_ECHO_OFF:
+        if(count != 0)
+        {
+          struct pam_response *reply_tmp = new struct pam_response[count + 1];
+          memcpy(reply_tmp, reply, count);
+          delete[] reply;
+          reply = reply_tmp;
+        }
+        // is this really how it should be done?
+        if(msg[i]->msg_style == PAM_PROMPT_ECHO_ON)
+          reply[i].resp = strndup(auth_data->user_name.c_str(),
+              auth_data->user_name.size());
+        else
+          reply[i].resp = strndup(auth_data->password.c_str(),
+              auth_data->password.size());
+
+        reply[count++].resp_retcode = PAM_SUCCESS;
+        break;
+
+      case PAM_TEXT_INFO:
+        break;
+
+      case PAM_ERROR_MSG:
+      default:
+        delete[] reply;
+        return PAM_CONV_ERR;
+    }
+  }
+  *resp = reply;
+  return PAM_SUCCESS;
+}
Index: Commands.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands.h,v
retrieving revision 1.65
retrieving revision 1.80
diff -u -p -b -r1.65 -r1.80
--- Commands.h	10 Jul 2004 14:14:45 -0000	1.65
+++ Commands.h	22 Jan 2005 17:18:50 -0000	1.80
@@ -16,91 +16,102 @@
 #include "Configuration.h"
 #include "Handler.h"
 #include "StringTokenizer.h"
+#include "Log.h"
 #endif
 
 class Commands
 {
   private:
     string parsedir(User*, string);
-    string mod_time(string, struct stat);
+    string mod_time(struct stat);
     string mlsx(User*, string);
-    string list_file(User*, string);
+    string list_file(string);
     string mlst_string(User*);
   public:
-    bool user(User*, string);
-    bool pass(User*, string);
-    bool retr(User*, string);
-    bool stor(User*, string);
-    bool port(User*, string);
-    bool quit(User*, string);
-    bool list(User*, string);
-    bool help(User*, string);
-    bool mkd(User*, string);
-    bool rmd(User*, string);
-    bool cwd(User*, string);
-    bool cdup(User*, string);
-    bool dele(User*, string);
-    bool pasv(User*, string);
+    bool user(User*, string, unsigned int);
+    bool pass(User*, string, unsigned int);
+    bool retr(User*, string, unsigned int);
+    bool stor(User*, string, unsigned int);
+    bool port(User*, string, unsigned int);
+    bool quit(User*, string, unsigned int);
+    bool list(User*, string, unsigned int);
+    bool help(User*, string, unsigned int);
+    bool mkd(User*, string, unsigned int);
+    bool rmd(User*, string, unsigned int);
+    bool cwd(User*, string, unsigned int);
+    bool dele(User*, string, unsigned int);
+    bool pasv(User*, string, unsigned int);
     bool ftp_send(User*, string);
     bool ftp_receive(User*, string&);
-    bool rname(User*, string);
-    bool opts(User*, string);
-    bool rest(User*, string);
-    bool abor(User*, string);
+    bool rname(User*, string, unsigned int);
+    bool opts(User*, string, unsigned int);
+    bool rest(User*, string, unsigned int);
+    bool abor(User*, string, unsigned int);
     // functions for simple commands that don't justify an own function
-    bool sim1(User*, string);
-    bool sim2(User*, string);
+    bool sim1(User*, string, unsigned int);
+    bool sim2(User*, string, unsigned int);
+    sem_t pam_lock; // pam is not threadsafe.
 #ifdef USE_TLS
     // collection of encryption commands
-    bool auth(User*, string);
-    gnutls_session init_tls(void);
+    bool auth(User*, string, unsigned int);
+    void init_tls(gnutls_session&);
 #endif // USE_TLS
 };
 
 // the extra flags we can play with...
-#define COM_LONG 1  // for list()
-#define COM_SHORT 2 
-#define COM_MLSD 3
-
-#define COM_FROM 4 // for rname()
-#define COM_TO 5
-
-#define COM_STOR 6 // for stor()
-#define COM_APPE 7
-
-#define COM_NOOP 10 // for sim1()
-#define COM_PWD  11 
-#define COM_SYST 12 
-#define COM_CDUP 13
-#define COM_FEAT 14
-#define COM_TYPE 15
-#define COM_MODE 16
-#define COM_STRU 17
+#define COM_LONG (1 << 0)  // for list()
+#define COM_SHORT (1 << 1) 
+#define COM_MLSD (1 << 2)
+
+#define COM_FROM (1 << 0) // for rname()
+#define COM_TO (1 << 1)
+
+#define COM_STOR (1 << 0) // for stor()
+#define COM_APPE (1 << 1)
+
+#define COM_CDUP (1 << 0)
+#define COM_CWD  (1 << 1)
+
+#define COM_NOOP (1 << 0) // for sim1()
+#define COM_PWD  (1 << 1)
+#define COM_SYST (1 << 2)
+#define COM_FEAT (1 << 3)
+#define COM_TYPE (1 << 4)
+#define COM_MODE (1 << 5)
+#define COM_STRU (1 << 6)
 #ifdef USE_TLS
-#define COM_PBSZ 50
-#define COM_PROT 51
-#define COM_CCC  52
+#define COM_PBSZ (1 << 7)
+#define COM_PROT (1 << 8)
+#define COM_CCC  (1 << 9)
+#define COM_CONF (1 << 10)
+#define COM_MIC (1 << 11)
+#define COM_ENC (1 << 12)
 #endif // USE_TLS
 
-#define COM_SIZE 20 // for sim2()
-#define COM_MDTM 21
-#define COM_MLST 22
-
-#define COM_PORT 25 // port and pasv
-#define COM_EPRT 26
-#define COM_PASV 27
-#define COM_EPSV 28
+#define COM_SIZE (1 << 0) // for sim2()
+#define COM_MDTM (1 << 1)
+#define COM_MLST (1 << 2)
+
+#define COM_PORT (1 << 0) // port and pasv
+#define COM_EPRT (1 << 1)
+#define COM_PASV (1 << 2)
+#define COM_EPSV (1 << 3)
 
+#define BEFORE_USER (1 << 31) // remember that these are used in conunctions with those above..
+#define LAST_COM (1 << 30)
 
 #define PROT_IPV4 1 // EPRT and EPSV
 #define PROT_IPV6 2
 
-void *data_wrapper(void*);
+#define READ_SIZE 16384
+
+#define PWBUF_SIZE 100
+
+void *data_wrapper(void*) __attribute__ ((noreturn));
 
 extern class Configuration *config;
 extern class Utilities util;
 extern class Handler handler;
-extern pthread_mutex_t sys_log_lock;
 extern vector<User*> user_list;
 
 #ifdef USE_TLS
@@ -110,4 +121,12 @@ extern gnutls_datum tls_db_fetch(void*, 
 extern int tls_db_delete(void*, gnutls_datum);
 #endif // USE_TLS
 
+int pam_conversate(int, const struct pam_message**,
+    struct pam_response**, void*);
+
+struct pam_data {
+  string user_name;
+  string password;
+};
+
 #endif
